#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <windows.h>

#define NORMAL 0
#define IN_KLAMMER 1

FILE *datei,*ziel;
int size,osize,lsize;
char *buffer;
char *symbol,*osymbol;
int i;

BOOL getLine()
{//liest eine ganze Zeile (bis '\n') aus der datei
  BYTE *zeichen;

  //lesepuffer fr ein zeichen anlegen und initialisieren
  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';

  //zeilenpuffer neu initialisieren
  *buffer = '\0';
  lsize = 0;

  //zeile aus der datei lesen... (abbrechen bei dateiende)
  if((fread(zeichen,sizeof(BYTE),1,datei)) == 0)
    return(false);

  while(*zeichen != '\n')
  {
    lsize++;
    buffer = (char *)realloc(buffer,lsize+1);
    strncat(buffer,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    fread(zeichen,sizeof(BYTE),1,datei);
  }

  //das letzte zeichen noch anfgen
  lsize++;
  buffer = (char *)realloc(buffer,lsize+1);
  strncat(buffer,(char *)zeichen,1);

  //printf("%s\n",buffer);
  fwrite(buffer,lsize,1,ziel);
  free(zeichen);
  return(true);
}


BOOL scanLine()
{//liefert alles zwischen leerzeichen, tabs, return und den uersten klammern
  BYTE *zeichen;
  int modus = NORMAL;
  int cc = 0; 
  //int i = 0;

  //neue zeile aus der datei einlesen
  if(i == lsize)
  {
    i = 0;
    if(!getLine())
      return(false);
  }

  zeichen = (BYTE *)malloc(sizeof(BYTE));
  *zeichen = '\0';

  //leerzeichen, tabs und returns 'weglesen'
  *zeichen = (BYTE)(*(buffer+i));
  while(((*zeichen == ' ') || (*zeichen == '\t') || (*zeichen == '\n')) && (i<lsize))
  {
      i++;
      *zeichen = (BYTE)(*(buffer+i));
  }
  
  //wenn zeile schon komplett gescannt (nur leerzeichen, tabs bzw. return)
  if(i == lsize)
    return(true);

  //vorhergehendes symbol sichern
  free(osymbol);
  osymbol = (char *)malloc(size+1);
  strncpy(osymbol,symbol,size+1);
  osize = size;
  
  //puffer neu initialisieren
  *symbol = '\0';
  size = 0;

  //evtl. in besonderen klammermodus gehen
  if(*zeichen == '(')
    modus = IN_KLAMMER;

  //abbruchbedingungen fr das einlesen
  while(((modus == NORMAL) && (*zeichen != ' ') && (i < lsize) && (*zeichen != '\t')) || ((modus == IN_KLAMMER) && (i < lsize)))
  {
    //zeichen im puffer zusammensetzen
    size++;
    symbol = (char *)realloc(symbol,size+1);
    strncat(symbol,(char *)zeichen,1);
    
    //nchstes zeichen lesen
    i++;
    *zeichen = (BYTE)(*(buffer+i));
        
    //anzahl der ffnenden klammern speichern
    if(*zeichen == '(')
    {
      modus = IN_KLAMMER;
      cc++;
    }

    //anzahl der schlieenden klammern...
    if(*zeichen == ')')
      cc--;

    //keine klammer mehr offen => wieder in normalen modus gehen
    if(cc == 0)
      modus = NORMAL;
  }

  //printf("SYMBOL: %s\n",symbol);

  free(zeichen);
  return(true);
}


int main(int argc, char* argv[])
{
  char *statement;

	if(argc != 3)
  {
    printf("tracer <quelldatei> <zieldatei>");
    return(0);
  }

	printf("TRACER...");

  //quelldatei zum lesen ffnen
	if((datei=fopen(argv[1],"r")) == NULL)
	{ 
    printf("Fehler beim ffnen der Datei %s\n",argv[1]);
		return(-1);
	}

  //zieldatei zum schreiben ffnen
	if((ziel=fopen(argv[2],"w")) == NULL)
	{ 
    printf("Fehler beim ffnen der Datei %s\n",argv[2]);
		return(-1);
	}

  //zeilenpuffer einrichten
  buffer = (char *)malloc(1);
  *buffer = '\0';

  //symbolpuffer einrichten
  symbol = (char *)malloc(1);
  *symbol = '\0';

  //methoden-oder funktionskopf finden
  while(scanLine())
  {
    if(*symbol == '{')
    {
      if((strncmp("=",osymbol,1)) == 0)
        continue;

      if((strncmp("do",osymbol,2)) == 0)
        continue;
      
      if((strncmp("if",osymbol,2)) == 0)
        continue;
     
      if((strncmp("for",osymbol,3)) == 0)
        continue;

      if((strncmp("else",osymbol,4)) == 0)
        continue;

      if((strncmp("_asm",osymbol,4)) == 0)
        continue;

      if((strncmp("union",osymbol,5)) == 0)
        continue;

      if((strncmp("while",osymbol,5)) == 0)
        continue;

      if((strncmp("struct",osymbol,6)) == 0)
        continue;

      if((strncmp("switch",osymbol,6)) == 0)
        continue;
      
      //erfolg => mit sehr hoher wahrscheinlichkeit funktionskopf gefunden
      //printf("Methoden- bzw. Funktionskopf gefunden\n");

      statement = (char *)malloc(200 + strlen(argv[1]) + osize);
      *statement = '\0';
      strncat(statement,"//hpp***************************************************************************\n",81);
      strncat(statement,"fprintf(trace,\"%u\t\t",19);
      strncat(statement,argv[1],strlen(argv[1]));
      strncat(statement,"\t\t",2);
      strncat(statement,osymbol,osize-1); //osize-1, da das letzte zeichen='\n'
      strncat(statement,"\\n\",time(zidx));\n",17);
      strncat(statement,"//pph***************************************************************************\n",81);
  
      //printf("%s\n",statement);

      fwrite(statement,199+strlen(argv[1])+osize,1,ziel);
      
      free(statement);
    }
  }

  free(buffer);
  free(symbol);
  free(osymbol);
  fclose(datei);
  fclose(ziel);
  
  printf("fertig\n");
  return (0);
}
